/*
 * Created on 2004. 2. 6.
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package nemo.model;

import java.util.BitSet;

/**
 * @author â
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class BasicSolverStrategy implements SolverStrategy {

	private Nemo nemo;
	private long current;

	/* (non-Javadoc)
	 * @see nemo.model.SolverStrategy#solve(nemo.model.Nemo)
	 */
	public void solve(Nemo nemo) {
		this.nemo = nemo;
		System.out.println("Generating permutations ...");
		SolverRow[] row = permuteRows(nemo.getRows(), true);
		double rowPerms = countPermutations(row);
		System.out.println(rowPerms + " row permutations");
		SolverRow[] col = permuteRows(nemo.getCols(), false);
		double colPerms = countPermutations(col);
		System.out.println(colPerms + " column permutations");
		if (rowPerms > colPerms) {
			System.out.println("Selected column permutations.");
			SolverRow[] temp = row;
			row = col;
			col = temp;
		}
		reducePermutations(row, col);
		System.out.println("Reduced permutations to "
				+ countPermutations(row));
		System.out.println("Looking for solutions ...");
		check(row, 0);
	}

	private SolverRow[] permuteRows(Row[] row, boolean isRow) {
		SolverRow[] result = new SolverRow[row.length];
		for (int i = 0; i < row.length; i++) {
			result[i] = new SolverRow(row[i], isRow, i);
		}
		return result;
	}
	
	private double countPermutations(SolverRow[] row) {
		double total = 1;
		for (int i = 0; i < row.length; i++) {
			int n = 0;
			for (int j = 0; j < row[i].countPermutations(); j++) {
				if (row[i].getPermutation(j) != null)
					n++;
			}
			total *= n;
		}
		return total;
	}

	private void reducePermutations(SolverRow[] p, SolverRow[] q) {
		for (int i = 0; i < q.length; i++) {
			BitSet[] s = q[i].combine();
			for (int j = 0; j < nemo.getNCols(); j++) {
				if (!s[0].get(j)) {
					validatePermutation(p, j, i);
				}
			}
		}
	}

	private void validatePermutation(SolverRow[] p, int row, int col) {
		for (int k = 0; k < p[row].countPermutations(); k++) {
			if (p[row].getPermutation(k) == null)
				continue;
			if (!p[row].getPermutation(k).get(col))
				p[row].disablePermutation(k);
		}
	}

	private void check(SolverRow[] p, int row) {
		if (row >= p.length) {
			current++;
			System.out.print(current + "\r");
			if (nemo.finished()) {
				showSolution();
			}
			return;
		}
		for (int i = 0; i < p[row].countPermutations(); i++) {
			if (p[row].getPermutation(i) == null)
				continue;
			p[row].setPermutation(i);
			check(p, row+1);
		}
	}

	private void showSolution() {
		System.out.print("\nSolution:\n\n  ");
		for (int col = 0; col < nemo.getNCols(); col++) {
			System.out.print((col + 1) % 10);
		}
		System.out.println('\n');
		for (int row = 0; row < nemo.getNRows(); row++) {
			System.out.print((row + 1) % 10);
			System.out.print(' ');
			for (int col = 0; col < nemo.getNCols(); col++) {
				if (nemo.marked(row, col)) {
					System.out.print('*');
				} else if (nemo.flagged(row, col)) {
					System.out.print('X');
				} else {
					System.out.print(' ');
				}
			}
			System.out.println();
		}
	}
}
