package nemo.model;
public class RandomNemo extends Nemo {
	private int nMarks;

	public RandomNemo(int nRows, int nCols, int nMarks) {
		super(nRows, nCols);
		this.nMarks = nMarks;
	}

	public void newGame() {
		unmarkAll();
		markRandomly();
		makeNumbers();
		unmarkAll();
		unflagAll();
		sendEvent();
	}

	private void unmarkAll() {
		for (int i = 0; i < getNRows(); i++) {
			for (int j = 0; j < getNCols(); j++) {
				unmark(i, j);
			}
		}
	}

	private void markRandomly() {
		for (int i = 0; i < nMarks; i++) {
			int row = -1;
			int col = -1;
			while (true) {
				row = (int) (Math.random() * getNRows());
				col = (int) (Math.random() * getNCols());
				if (!marked(row, col))
					break;
			}
			mark(row, col);
		}
	}
}
