package nemo.model;

import java.util.BitSet;

/**
 * @author Changbeom Ahn
 */
public class Row {
	private Numbers numbers;
	protected Nemo nemo;
	protected int row;
	protected Cell[] cell;
	
	public Numbers getNumbers() {
		return numbers;
	}
	
	public BitSet getMarks() {
		BitSet marks = new BitSet(cell.length);
		for (int i = 0; i < cell.length; i++) {
			if (cell[i].marked()) {
				marks.set(i);
			}
		}
		return marks;
	}
	
	/**
	 * Method mark.
	 * @param i
	 * @deprecated Use Nemo.mark() instead.
	 */
	public void mark(int i) {
		get(i).mark(true);
	}

	/**
	 * Method unmark.
	 * @param i
	 * @deprecated Use Nemo.unmark() instead.
	 */
	public void unmark(int i) {
		get(i).mark(false);
	}

	/**
	 * Method flag.
	 * @param i
	 * @deprecated Use Nemo.flag() instead.
	 */
	public void flag(int i) {
		get(i).flag(true);
	}
	
	public Cell get(int i) {
		return cell[i];
	}
	
	public Row(Nemo nemo, int row, Cell[][] cell, Numbers numbers) {
		this.nemo = nemo;
		this.row = row;
		this.numbers = numbers;
		setCell(cell);
	}
	
	protected void setCell(Cell[][] cell) {
		this.cell = new Cell[nemo.getNCols()];
		for (int i = 0; i < nemo.getNCols(); i++) {
			this.cell[i] = cell[row][i];
		}
	}

	/**
	 * Method setNumbers.
	 * @param numbers
	 */
	public void setNumbers(Numbers numbers) {
		this.numbers = numbers;
	}
	
	public boolean finished() {
		return Marks.toNumbers(getMarks()).equals(getNumbers());
	}

	public Nemo getNemo() {
		return nemo;
	}

	public BitSet getFlags() {
		BitSet flags = new BitSet(cell.length);
		for (int i = 0; i < cell.length; i++) {
			if (cell[i].flagged()) {
				flags.set(i);
			}
		}
		return flags;
	}
}
