/*
 * Created on 2004. 2. 6.
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package nemo.model;

import java.util.Arrays;
import java.util.Vector;

/**
 * @author â
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class SmartSolverStrategy implements SolverStrategy, CellListener {

	private final int MAX_PERMUTATIONS = 100000;
	
	private Nemo nemo;
	private Vector updates = new Vector();
	private SolverRow[] row;
	private SolverRow[] col;

	/* (non-Javadoc)
	 * @see nemo.model.SolverStrategy#solve(nemo.model.Nemo)
	 */
	public void solve(Nemo nemo) {
		this.nemo = nemo;
		//nemo.addCellListener(this);
		System.out.println("Generating permutations ...");
		row = permuteRows(nemo.getRows(), true);
		col = permuteRows(nemo.getCols(), false);
		//System.out.println("row before: " + countPermutations(row));
		//System.out.println("col before: " + countPermutations(col));
		SolverRow[] all = unionRows(row, col);
		Arrays.sort(all);
		combineRows(all);
		checkEmpty(all);
		
		double numRowPerms = countPermutations(row);
		double numColPerms = countPermutations(col);
		
		for (int i = 0; i < 100; i++) {
			if (nemo.finished()) {
				System.out.println("Finished after " + i + " iterations.");
				break;
			}
			checkFull(all);
			checkPermutations(all);
			combineRows(all);
			checkFinished(all);
			
			double nr = countPermutations(row);
			double nc = countPermutations(col);
			System.out.println("row after: " + nr);
			System.out.println("col after: " + nc);
			if ((numRowPerms - nr) / numRowPerms < .9 &&
					(numColPerms - nc) / numColPerms < .9) {
				if (Permuter.getMax() >= MAX_PERMUTATIONS) {
					System.out.println("I can't solve this puzzle");
					return;
				}
				Permuter.setMax(Permuter.getMax() * 2);
			}
			numRowPerms = nr;
			numColPerms = nc;
			
			showSolution();
		}
	}

	private void checkFinished(SolverRow[] all) {
		for (int i = 0; i < all.length; ++i) {
			all[i].checkFinished();
		}
	}

	private SolverRow[] permuteRows(Row[] row, boolean isRow) {
		SolverRow[] result = new SolverRow[row.length];
		for (int i = 0; i < row.length; i++) {
			result[i] = new SolverRow(row[i], isRow, i);
		}
		return result;
	}

	private double countPermutations(SolverRow[] row) {
		double total = 1;
		for (int i = 0; i < row.length; i++) {
			int n = 0;
			for (int j = 0; j < row[i].countPermutations(); j++) {
				if (row[i].getPermutation(j) != null)
					n++;
			}
			total *= n;
		}
		return total;
	}

	private SolverRow[] unionRows(SolverRow[] row, SolverRow[] col) {
		SolverRow[] result = new SolverRow[row.length + col.length];
		System.arraycopy(row, 0, result, 0, row.length);
		System.arraycopy(col, 0, result, row.length, col.length);
		return result;
	}

	private void combineRows(SolverRow[] row) {
		for (int i = 0; i < row.length; i++) {
/*			while (!updates.isEmpty()) {
				int[] pos = (int[]) updates.get(0);
				updates.remove(0);
				int r = pos[0];
				int c = pos[1];
				System.out.println("updating " + r + "," + c);
				if (this.row[r].getPoint() > row[i].getPoint()) {
					this.row[r].checkPermutations();
				}
				if (this.col[c].getPoint() > row[i].getPoint()) {
					col[c].checkPermutations();
				}
			}*/
			row[i].mark(row[i].combine());
		}
	}

	private void checkEmpty(SolverRow[] row) {
		for (int i = 0; i < row.length; i++) {
			row[i].checkEmpty();
		}
	}

	private void checkFull(SolverRow[] row) {
		for (int i = 0; i < row.length; i++) {
			row[i].checkFull();
		}
	}

	private void checkPermutations(SolverRow[] all) {
		for (int i = 0; i < all.length; i++) {
			all[i].checkPermutations();
		}
	}

	private void showSolution() {
		System.out.print("\nSolution:\n\n  ");
		for (int col = 0; col < nemo.getNCols(); col++) {
			System.out.print((col + 1) % 10);
		}
		System.out.println('\n');
		for (int row = 0; row < nemo.getNRows(); row++) {
			System.out.print((row + 1) % 10);
			System.out.print(' ');
			for (int col = 0; col < nemo.getNCols(); col++) {
				if (nemo.marked(row, col)) {
					System.out.print('*');
				} else if (nemo.flagged(row, col)) {
					System.out.print('X');
				} else {
					System.out.print(' ');
				}
			}
			System.out.println();
		}
	}

	public void cellModified(CellEvent e) {
		int[] pos = new int[2];
		pos[0] = e.getRow();
		pos[1] = e.getCol();

		if (updates.indexOf(pos) == -1) {
			updates.add(pos);
		}
	}
}
