package nemo.swingui;
import javax.swing.*;

import nemo.model.*;

import java.awt.*;

public class ColLabels extends JPanel implements NemoListener, CellListener {
	private Nemo nemo;
	private Dimension d;
	private int height;
	private int offset;

	public ColLabels(Nemo nemo) {
		this.nemo = nemo;
		nemo.addNemoListener(this);
		nemo.addCellListener(this);
	}

	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		FontMetrics fm = g.getFontMetrics();
		Graphics2D g2 = (Graphics2D) g;
		// g2.drawRect(0, 0, d.width-1, d.height-1);
		g2.rotate(Math.PI / 2);
		for (int i = 0; i < nemo.getNCols(); i++) {
			if (nemo.checkCol(i))
				g.setColor(Color.white);
			else
				g.setColor(Color.black);
			String label = nemo.getColNumbers(i).toString();
			g2.drawString(label, d.height - fm.stringWidth(label),
					-offset - i*height);
		}
	}

	public Dimension getPreferredSize() {
		return getMinimumSize();
	}
	
	public Dimension getMinimumSize() {
		FontMetrics fm = getGraphics().getFontMetrics();
		height = fm.getHeight();
		offset = fm.getLeading()/2 + fm.getDescent();
		int max = 0;
		for (int i = 0; i < nemo.getNCols(); i++) {
			int width = fm.stringWidth(
				nemo.getColNumbers(i).toString());
			if (width > max)
				max = width;
		}
		d = new Dimension(nemo.getNCols()*height, max);
		return d;
	}

	public void nemoLoaded(NemoEvent e) {
		repaint();
	}

	/* (non-Javadoc)
	 * @see nemo.model.CellListener#cellModified(nemo.model.CellEvent)
	 */
	public void cellModified(CellEvent e) {
		// TODO Auto-generated method stub
		repaint();
	}
}
