package nemo.swingui;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import nemo.model.RandomNemo;

public class RandomNemoUI implements ActionListener {
	private RandomNemo nemo;
	private JFrame frame;

	public static void main(String[] args) {
		new RandomNemoUI();
	}

	public RandomNemoUI() {
		try {
			nemo = new RandomNemo(8, 8, 54);
			nemo.newGame();
		}
		catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}

		frame = new JFrame("׸");
		// JDK 1.3 ʿ
		// frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setDefaultCloseOperation(
			WindowConstants.DO_NOTHING_ON_CLOSE);
		frame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(1);
			}
		});
		Container contentPane = frame.getContentPane();
		GridBagLayout gridbag = new GridBagLayout();
		contentPane.setLayout(gridbag);
		GridBagConstraints c = new GridBagConstraints();

		JButton button = new JButton("");
		button.addActionListener(this);
		c.gridwidth = 2;
		gridbag.setConstraints(button, c);
		contentPane.add(button);

		ColLabels colLabels = new ColLabels(nemo);
		c.gridwidth = 1;
		c.gridx = 1;
		c.gridy = 1;
		gridbag.setConstraints(colLabels, c);
		contentPane.add(colLabels);

		Picture picture = new Picture(nemo);
		c.gridy = 2;
		gridbag.setConstraints(picture, c);
		contentPane.add(picture);

		RowLabels rowLabels = new RowLabels(nemo);
		c.gridx = 0;
		gridbag.setConstraints(rowLabels, c);
		contentPane.add(rowLabels);

		frame.pack();
		frame.setVisible(true);
		// frame.setResizable(false);
	}

	public void actionPerformed(ActionEvent e) {
		nemo.newGame();
		frame.pack();
		frame.repaint();
	}
}
