package nemo.swingui;
import javax.swing.*;

import nemo.model.*;

import java.awt.*;

public class RowLabels extends JPanel implements NemoListener, CellListener {
	private Dimension d;
	private Nemo nemo;
	private int height;
	private int offset;

	public RowLabels(Nemo nemo) {
		this.nemo = nemo;
		nemo.addNemoListener(this);
		nemo.addCellListener(this);
	}

	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		// g.drawRect(0, 0, d.width-1, d.height-1);
		FontMetrics fm = g.getFontMetrics();
		for (int i = 0; i < nemo.getNRows(); i++) {
			if (nemo.checkRow(i))
				g.setColor(Color.white);
			else
				g.setColor(Color.black);
			String label = nemo.getRowNumbers(i).toString();
			g.drawString(label, d.width - fm.stringWidth(label),
					offset + i*height);
		}
	}

	public Dimension getPreferredSize() {
		return getMinimumSize();
	}
	
	public Dimension getMinimumSize() {
		FontMetrics fm = getGraphics().getFontMetrics();
		height = fm.getHeight();
		offset = fm.getLeading()/2 + fm.getAscent();
		int max = 0;
		for (int i = 0; i < nemo.getNRows(); i++) {
			Numbers numbers = nemo.getRowNumbers(i);
			int width = fm.stringWidth(numbers.toString());
			if (width > max)
				max = width;
		}
		d = new Dimension(max, nemo.getNRows() * height);
		return d;
	}

	public void nemoLoaded(NemoEvent e) {
		repaint();
	}

	/* (non-Javadoc)
	 * @see nemo.model.CellListener#cellModified(nemo.model.CellEvent)
	 */
	public void cellModified(CellEvent e) {
		// TODO Auto-generated method stub
		repaint();
	}
}
