package nemo.swingui;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.net.URL;

import nemo.model.Nemo;
import nemo.model.PBNInputStream;
import nemo.model.SmartSolverStrategy;
import nemo.model.Solver;

public class SolverApplet extends JApplet implements ActionListener {
	private Nemo nemo;

	public void init() {
		try {
			String urlParam = getParameter("URL");
			URL url = new URL(urlParam);
			InputStream is = new PBNInputStream(url);
			Reader in = new InputStreamReader(is);
			nemo = new Nemo(in);
		}
		catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}

		Container contentPane = getContentPane();
		GridBagLayout gridbag = new GridBagLayout();
		contentPane.setLayout(gridbag);
		GridBagConstraints c = new GridBagConstraints();

		JButton button = new JButton("ذ!");
		button.addActionListener(this);
		c.gridwidth = 2;
		gridbag.setConstraints(button, c);
		contentPane.add(button);

		ColLabels colLabels = new ColLabels(nemo);
		c.gridwidth = 1;
		c.gridx = 1;
		c.gridy = 1;
		gridbag.setConstraints(colLabels, c);
		contentPane.add(colLabels);

		Picture picture = new Picture(nemo);
		c.gridy = 2;
		gridbag.setConstraints(picture, c);
		contentPane.add(picture);

		RowLabels rowLabels = new RowLabels(nemo);
		c.gridx = 0;
		gridbag.setConstraints(rowLabels, c);
		contentPane.add(rowLabels);

		// setVisible(true);
	}

	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent arg0) {
		Solver solver = new Solver();
		solver.setStrategy(new SmartSolverStrategy());
		solver.solve(nemo);
	}
}
