package nemo.swingui;
import java.io.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.net.URL;
import nemo.model.Nemo;

public class SwingApplet extends JApplet implements ActionListener {
	private Nemo nemo;

	public void init() {
		String puzzle = getParameter("PUZZLE");
		if (puzzle == null)
			puzzle = "1 1;1;1;";
		puzzle = puzzle.replace(';', '\n');
		Reader in = new StringReader(puzzle);
		try {
			nemo = new Nemo(in);
		}
		catch (IOException e) {
			e.printStackTrace();
		}

		Container contentPane = getContentPane();
		GridBagLayout gridbag = new GridBagLayout();
		contentPane.setLayout(gridbag);
		GridBagConstraints c = new GridBagConstraints();

		JButton button = new JButton("dummy");
		button.addActionListener(this);
		c.gridwidth = 2;
		gridbag.setConstraints(button, c);
		contentPane.add(button);

		ColLabels colLabels = new ColLabels(nemo);
		c.gridwidth = 1;
		c.gridx = 1;
		c.gridy = 1;
		gridbag.setConstraints(colLabels, c);
		contentPane.add(colLabels);

		Picture picture = new Picture(nemo);
		c.gridy = 2;
		gridbag.setConstraints(picture, c);
		contentPane.add(picture);

		RowLabels rowLabels = new RowLabels(nemo);
		c.gridx = 0;
		gridbag.setConstraints(rowLabels, c);
		contentPane.add(rowLabels);

		setVisible(true);
	}

	public void actionPerformed(ActionEvent e) {
		URL codeBase = getCodeBase();
		showStatus(codeBase.toString());
	}
}
