package nemo.swingui;

import java.awt.*;
import java.io.FileReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.net.URL;

import javax.swing.*;

import nemo.model.*;

public class SwingSolver {
	private Nemo nemo;
	private long current;

	public static void main(String[] args) {
		try {
			//System.out.println("Solving " + args[0] + " ...");
			//Nemo nemo = new Nemo(new FileReader(args[0]));
			URL url = new URL("http://pbn.homelinux.com/pbn/cgi-bin/PBNPuzzle.cgi/35x35/20041116cTIB.pbn");
			InputStream is = new PBNInputStream(url);
			Reader in = new InputStreamReader(is);
			Nemo nemo = new Nemo(in);

			JFrame frame = new JFrame("Solver");

			Container contentPane = frame.getContentPane();
			GridBagLayout gridbag = new GridBagLayout();
			contentPane.setLayout(gridbag);
			GridBagConstraints c = new GridBagConstraints();

			JButton button = new JButton("Stop");
			//button.addActionListener(this);
			c.gridwidth = 2;
			gridbag.setConstraints(button, c);
			contentPane.add(button);

			ColLabels colLabels = new ColLabels(nemo);
			c.gridwidth = 1;
			c.gridx = 1;
			c.gridy = 1;
			gridbag.setConstraints(colLabels, c);
			contentPane.add(colLabels);

			Picture picture = new Picture(nemo);
			c.gridy = 2;
			gridbag.setConstraints(picture, c);
			contentPane.add(picture);

			RowLabels rowLabels = new RowLabels(nemo);
			c.gridx = 0;
			gridbag.setConstraints(rowLabels, c);
			contentPane.add(rowLabels);

			frame.pack();
			frame.setVisible(true);
			// frame.setResizable(false);

			Solver solver = new Solver();
			solver.setStrategy(new SmartSolverStrategy());
			solver.solve(nemo);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

}
