package nemo.tests;
import java.util.BitSet;

import junit.framework.TestCase;
import nemo.model.*;

public class MarksTest extends TestCase {
	private Marks marks;
	private BitSet bset;

	public MarksTest(String name) {
		super(name);
	}

	protected void setUp() {
		marks = new Marks(3);
		bset = new BitSet();
	}

	public void testSize() {
		assertEquals(3, marks.size());
	}

	public void testMarked() {
		assertTrue(!marks.marked(0));
	}

	public void testMark() {
		marks.mark(0);
		assertTrue(marks.marked(0));
	}

	public void testUnmark() {
		marks.mark(0);
		marks.unmark(0);
		assertTrue(!marks.marked(0));
	}

	public void testToNumbers() {
		Numbers numbers = new Numbers();
		numbers.add(1);
		bset.set(0);
		assertTrue(Marks.toNumbers(bset).equals(numbers));
		numbers.add(1);
		bset.set(2);
		assertTrue(Marks.toNumbers(bset).equals(numbers));
	}
}
