package nemo.tests;
import java.util.BitSet;

import junit.framework.TestCase;
import nemo.model.Permuter;

public class PermuterTest extends TestCase {
	public PermuterTest(String name) {
		super(name);
	}

	public void testPermute() {
		final String[] expected = {"{0, 1, 2, 4, 5}", "{0, 1, 2, 5, 6}", 
				"{1, 2, 3, 5, 6}"};
		BitSet[] p = Permuter.permute(7, new int[] {3, 2}, null);
		assertEquals(expected.length, p.length);
		for (int i = 0; i < p.length; i++) {
			int j;
			for (j = 0; j < expected.length; j++) {
				System.out.println("p[" + i + "]: " + p[i].toString());
				if (expected[j].equals(p[i].toString())) {
					break;
				}
			}
			assertTrue(j < expected.length);
		}
	}
	
	public void testPermutationLength() {
		final int WIDTH = 40;
		Permuter.setMax(10000);
		BitSet[] bset = Permuter.permute(WIDTH, new int[] {4, 5}, null);
		for (int i = 0; i < bset.length; ++i) {
			System.out.println("p" + i + ": " + bset[i]);
			assertTrue(bset[i].length() <= WIDTH);
		}
	}

	public void testRepeat() {
		assertEquals("", Permuter.repeat('x', 0));
		assertEquals("o", Permuter.repeat('o', 1));
		assertEquals("TT", Permuter.repeat('T', 2));
		//            12345678901
		assertEquals("///////////", Permuter.repeat('/', 11));
		assertEquals("", Permuter.repeat('$', -1));
		assertEquals("", Permuter.repeat('%', -11));
	}
}
