package nemo.tests;
import junit.framework.TestCase;
import nemo.model.RandomNemo;

public class RandomNemoTest extends TestCase {
	public RandomNemoTest(String name) {
		super(name);
	}

	public void testNewGame() {
		RandomNemo rn = new RandomNemo(3, 3, 5);
		rn.newGame();
		int n = 0;
		for (int i = 0; i < rn.getNRows(); i++) {
			n += rn.getRowNumbers(i).sum();
		}
		assertEquals(5, n);
		n = 0;
		for (int i = 0; i < rn.getNCols(); i++) {
			n += rn.getColNumbers(i).sum();
		}
		assertEquals(5, n);
		for (int i = 0; i < rn.getNRows(); i++) {
			for (int j = 0; j < rn.getNCols(); j++) {
				assertEquals(false, rn.marked(i, j));
			}
		}
	}

	public void testDirtyNewGame() {
		RandomNemo rn = new RandomNemo(3, 4, 5);
		rn.mark(0, 0);
		rn.flag(0, 1);
		rn.newGame();
		for (int i = 0; i < rn.getNRows(); i++) {
			for (int j = 0; j < rn.getNCols(); j++) {
				assertTrue("marked", !rn.marked(i, j));
				assertTrue(i + ", " + j + " flagged", !rn.flagged(i, j));
			}
		}
	}
}
